#
# vim:set syntax=python:

#import os

import java 
import sys
import time
import re
from IAG.control import *

lineSeparator = java.lang.System.getProperty('line.separator') 

# ~~~~~~                                                                          
# ~     ~    ~~     ~~~~~    ~~     ~~~~    ~~~~   ~    ~  ~~~~~    ~~~~   ~~~~~~ 
# ~     ~   ~  ~      ~     ~  ~   ~       ~    ~  ~    ~  ~    ~  ~    ~  ~      
# ~     ~  ~    ~     ~    ~    ~   ~~~~   ~    ~  ~    ~  ~    ~  ~       ~~~~~  
# ~     ~  ~~~~~~     ~    ~~~~~~       ~  ~    ~  ~    ~  ~~~~~   ~       ~      
# ~     ~  ~    ~     ~    ~    ~  ~    ~  ~    ~  ~    ~  ~   ~   ~    ~  ~      
# ~~~~~~   ~    ~     ~    ~    ~   ~~~~    ~~~~    ~~~~   ~    ~   ~~~~   ~~~~~~ 
#                                                                                 
def checkMinConnectionPoolSize(cfg, dataSource, desiredSize = '0'):
	connectionPoolSize(cfg, dataSource, 'check', desiredSize, 'minConnections')


def checkMaxConnectionPoolSize(cfg, dataSource, desiredSize = '50'):
	connectionPoolSize(cfg, dataSource, 'check', desiredSize, 'maxConnections')


def setMinConnectionPoolSize(cfg, dataSource, desiredSize = '0'):
	connectionPoolSize(cfg, dataSource, 'set', desiredSize, 'minConnections')


def setMaxConnectionPoolSize(cfg, dataSource, desiredSize = '50'):
	connectionPoolSize(cfg, dataSource, 'set', desiredSize, 'maxConnections')


def connectionPoolSize(cfg, dataSource, request = 'check', desiredSize = '0', param = ''):
	pass
	# Help: Display syntax 
	if request == 'help': 
# 		print "Syntax: %s%sconnectionPoolSize(cfg, server, desiredSize)" % ( ('check', 'set')[ request == 'set' ] ), ('min', 'max')[ param == 'maxConnections' ]) )  
		print "" 
		print "   desiredSize   is in MegaBytes" 
		print "" 
		return True 
 
	try: 
		AdminConfig  = cfg.AdminConfig 
		AdminControl = cfg.AdminControl 
		AdminApp     = cfg.AdminApp 
		AdminTask    = cfg.AdminTask 
	except:  
		print "Can Load the wsadmin Modules" 
 
	# Get params 
	connectionPool = AdminConfig.list('ConnectionPool', dataSource[ 'ID' ]) 
	# provided arg 'param' is either 'minConnections' or 'maxConnections' 
	paramValue = AdminConfig.showAttribute(connectionPool, param) 
 
	# If paramValue = desired, skip all of this & will return true below 
 
	if paramValue != desiredSize: 
		# Return False if check 
		if request == 'check': 
			return False 
		# Set it to desired 
		elif request == 'set': 
			try: 
				AdminConfig.modify( connectionPool, [[ param, desiredSize ]] ) 
			except: 
				return False 
		# Unhandled bugger up 
		else: 
			print "Error, Somethings gone wrong" 
			return False 
	 
	# Everything either returns False or comes here 
	return True 
 

#                 ~~~~~~~                         
#                    ~     ~~~~~~   ~~~~    ~~~~~ 
#                    ~     ~       ~          ~   
#                    ~     ~~~~~    ~~~~      ~   
#                    ~     ~            ~     ~   
#                    ~     ~       ~    ~     ~   
#                    ~     ~~~~~~   ~~~~      ~   
#                                                 
def list(cfg, dataSource):
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"

# 	global cfg 
	list = []
	for dataSourceID in AdminConfig.list( 'DataSource', server[ 'ID' ] ).splitlines(): 
		dataSourceNm  = AdminConfig.showAttribute( dataSourceID, 'name') 
		if dataSourceNm == 'DefaultEJBTimerDataSource':
			continue

		try:
			dataSourceObj = getObjectName( cfg, dataSourceID )
		except:
			dataSourceObj = ''
		list.append({'name':dataSourceNm,         'ID':dataSourceID,     \
		             'objectNm':dataSourceObj,                           })
	server[ 'dataSources' ] = list
	return


def test(cfg, dataSource): 
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	# Tests a single DataSource
	# 
	# Tests (and response code)--
	# wsadmin>AdminControl.testConnection('transport_db(cells/SysOrmCell/clusters/SysOrmTransportConsumerCluster2|resources.xml#DataSource_1259816876453)') 
	# WASX7467I: Connection to provided datasource on node uaswas10N3 process SysOrmTransportConsumer2M1 was successful. 
	# WASX7467I: Connection to provided datasource on node uaswas11N3 process SysOrmTransportConsumer2M2 was successful. 
	# 'WASX7217I: Connection to provided datasource was successful.' 
	

# 	ds = AdminConfig.getid('/DataSource:DS1/') 
#  	print "\nTesting DataSource !!!!--- %s\n" % dataSource[ 'ID' ]  

	curTime = time.time()

	# define the iterator and/or check if it is time to check yet
	if iterationTime( cfg, dataSource, cfg.dsIterationTime ) == None:
		return None
	
	if dataSource[ 'name' ] == 'DefaultEJBTimerDataSource':
		dataSource[ 'lastStatus' ] = { 'bool': '1', 'msg': "DefaultEJBTimerDataSource is one of those dodgy dataSources, that polute our notion of what a datasource is - and I have no idea what its all about and test doesn't work \n -Ax", 'time': curTime }
		dateIteration( cfg, dataSource )
		return

	try:
		testerVar = AdminControl.testConnection( dataSource[ 'ID' ] )
	except:
		dataSource[ 'lastStatus' ] = { 'bool': '0', 'msg': 'Test Connection Unsucessful', 'time': curTime }
		dateIteration( cfg, dataSource )
		return '1'

	if   testerVar == 'WASX7217I: Connection to provided datasource was successful.':
		dataSource[ 'lastStatus' ] = { 'bool': '1', 'msg': testerVar, 'time': curTime }
		dateIteration( cfg, dataSource )
	elif testerVar == 'WASX7388E: Connection to provided datasource failed.':
		dataSource[ 'lastStatus' ] = { 'bool': '0', 'msg': testerVar, 'time': curTime }
		dateIteration( cfg, dataSource )
	else:
		dataSource[ 'lastStatus' ] = { 'bool': '0', 'msg': testerVar, 'time': curTime }
		dateIteration( cfg, dataSource )

	return '1'
