#
# vim:set syntax=python:
#import os

import java 
import sys
import time
import re
from IAG.control import *
from IAG.WebSphere import *
from time import gmtime, strftime

lineSeparator = java.lang.System.getProperty('line.separator') 

#    ~                     ~~~~~                                          
#   ~ ~    ~~~~~   ~~~~~  ~     ~  ~~~~~~  ~~~~~   ~    ~  ~~~~~~  ~~~~~  
#  ~   ~   ~    ~  ~    ~ ~        ~       ~    ~  ~    ~  ~       ~    ~ 
# ~     ~  ~    ~  ~    ~  ~~~~~   ~~~~~   ~    ~  ~    ~  ~~~~~   ~    ~ 
# ~~~~~~~  ~~~~~   ~~~~~        ~  ~       ~~~~~   ~    ~  ~       ~~~~~  
# ~     ~  ~       ~      ~     ~  ~       ~   ~    ~  ~   ~       ~   ~  
# ~     ~  ~       ~       ~~~~~   ~~~~~~  ~    ~    ~~    ~~~~~~  ~    ~ 
#                                                                         
def checkServerExists(cfg, server):
	serverExists(cfg, server, 'check')

def setServerExists(cfg, server):
	serverExists(cfg, server, 'set')

def serverExists(cfg, server):
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"

	print "Not Implemented Yet"
	return True

#                       ~ ~     ~ ~     ~         ~~~~~~                                          
#                       ~ ~     ~ ~~   ~~         ~     ~    ~~    ~~~~~     ~~    ~    ~   ~~~~  
#                       ~ ~     ~ ~ ~ ~ ~         ~     ~   ~  ~   ~    ~   ~  ~   ~~  ~~  ~      
#                       ~ ~     ~ ~  ~  ~         ~~~~~~   ~    ~  ~    ~  ~    ~  ~ ~~ ~   ~~~~  
#                 ~     ~  ~   ~  ~     ~         ~        ~~~~~~  ~~~~~   ~~~~~~  ~    ~       ~ 
#                 ~     ~   ~ ~   ~     ~         ~        ~    ~  ~   ~   ~    ~  ~    ~  ~    ~ 
#                  ~~~~~     ~    ~     ~         ~        ~    ~  ~    ~  ~    ~  ~    ~   ~~~~  
#                                                                                                 

def checkIntroscopeParams(cfg, server, ):
	# TODO: This def is ATM a theory . . . to be continued
	return JvmStuff(cfg, server, 'get', 'genericJvmArguments', 'true')

def setIntroscopeParams(cfg, server):
	# TODO: This def is ATM a theory . . . to be continued
	return JvmStuff(cfg, server, 'set', 'genericJvmArguments', 'true')

def checkVerboseGC(cfg, server):
	return JvmStuff(cfg, server, 'check', 'verboseModeGarbageCollection', 'true')

def setVerboseGC(cfg, server):
	return JvmStuff(cfg, server, 'set', 'verboseModeGarbageCollection', 'true')

def JvmStuff(cfg, server, request, param, desiredVal):
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"

	jvm = AdminConfig.list('JavaVirtualMachine', server[ 'ID' ] )
	paramVal = AdminConfig.showAttribute(jvm, param)

	if request == 'get':
		return paramVal

	if paramVal != desiredVal: 
		if request == 'check':
			return False
		# Set it to desired
		elif request == 'set':
			try:
				AdminConfig.modify( jvm, [[ param, desiredVal ]] )
			except:
				return False
		# Unhandled bugger up
		else:
			print "Error, Somethings gone wrong"
			return False
	return True

#                 ~                               
#                 ~         ~~~~    ~~~~    ~~~~  
#                 ~        ~    ~  ~    ~  ~      
#                 ~        ~    ~  ~        ~~~~  
#                 ~        ~    ~  ~  ~~~       ~ 
#                 ~        ~    ~  ~    ~  ~    ~ 
#                 ~~~~~~~   ~~~~    ~~~~    ~~~~  
#                                                 
def disLogHelp():
	print ""
	print "   params is a 4 field list with the following values --"
	print "   desiredType               can be 'TIME' or 'SIZE'"
	print "   desiredPeriod             is on hours"
	print "   desiredBaseHour           is an hour (0-23)"
	print "   desiredNumOfBackupFiles   is an integer"
	return True

def checkSysOutLog(cfg, server, params):
	# Help: Display syntax
	if params == 'help':
		print "Syntax: setSysErrLog(cfg, server, params)"
		disLogHelp
		return True
	logParams(cfg, server, 'check', 'outputStreamRedirect', params[ 'type' ], params[ 'period' ], params[ 'baseHour' ], params[ 'numBackups' ])


def checkSysErrLog(cfg, server, params):
	# Help: Display syntax
	if params == 'help':
		print "Syntax: setSysErrLog(cfg, server, params)"
		disLogHelp
		return True
	logParams(cfg, server, 'check', 'errorStreamRedirect', params[ 'type' ], params[ 'period' ], params[ 'baseHour' ], params[ 'numBackups' ])


def setSysOutLog(cfg, server, params):
	# Help: Display syntax
	if params == 'help':
		print "Syntax: setSysErrLog(cfg, server, params)"
		disLogHelp
		return True
	logParams(cfg, server, 'set', 'outputStreamRedirect', params[ 'type' ], params[ 'period' ], params[ 'baseHour' ], params[ 'numBackups' ])


def setSysErrLog(cfg, server, params):
	# Help: Display syntax
	if params == 'help':
		print "Syntax: setSysErrLog(cfg, server, params)"
		disLogHelp
		return True
	logParams(cfg, server, 'set', 'errorStreamRedirect', params[ 'type' ], params[ 'period' ], params[ 'baseHour' ], params[ 'numBackups' ])

   
def logParams(cfg, server, request, stream = 'outputStreamRedirect', desiredType = 'TIME', desiredPeriod = '24', desiredBaseHour = '24', desiredNumOfBackupFiles = '30'):
	# Help: Display syntax
	if request == 'help':
		print "Syntax: logParams(cfg, server, request , stream, desiredType, desiredPeriod, desiredbaseHour, desiredNumOfBackupFiles)"
		print ""
		print "   request                   can be 'check', 'set' or 'help'"
		print "   stream                    can be 'outputStreamRedirect' or 'errorStreamRedirect'"
		print "   desiredType               can be 'TIME' or 'SIZE'"
		print "   desiredPeriod             is on hours"
		print "   desiredBaseHour           is an hour (0-23)"
		print "   desiredNumOfBackupFiles   is an integer"
		return True

	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
		AdminApp     = cfg.AdminApp
		AdminTask    = cfg.AdminTask
	except: 
		print "Can Load the wsadmin Modules"


	# Get the sysOut and sysErr objs
	logObj = AdminConfig.showAttribute(server[ 'ID' ], stream)

	# Get params
	rolloverType = AdminConfig.showAttribute(logObj, 'rolloverType')
	rolloverSize = AdminConfig.showAttribute(sysOutLog, 'rolloverSize')
	rolloverPeriod = AdminConfig.showAttribute(sysOutLog, 'rolloverPeriod')
	baseHour = AdminConfig.showAttribute(sysOutLog, 'baseHour')
	maxNumberOfBackupFiles = AdminConfig.showAttribute(sysOutLog, 'maxNumberOfBackupFiles')

	# Print msg is there is a bad param
	if maxNumberOfBackupFiles != desiredNumOfBackupFiles	\
	          or rolloverType != desiredType              \
	        or rolloverPeriod != desiredPeriod            \
	              or baseHour != desiredBaseHour:
		if request == 'check':
			return False
		# Set it to desired
		elif request == 'set':
			try:
				AdminConfig.modify( logObj, [[ 'rolloverType',           desiredType             ]] )
				AdminConfig.modify( logObj, [[ 'rolloverPeriod',         desiredPeriod           ]] )
				AdminConfig.modify( logObj, [[ 'baseHour',               desiredBaseHour         ]] )
				AdminConfig.modify( logObj, [[ 'maxNumberOfBackupFiles', desiredNumOfBackupFiles ]] )
			except:
				return False
		# Unhandled bugger up
		else:
			print "Error, Somethings gone wrong"
			return False

		return False
	return true

#                 ~     ~                         
#                 ~     ~  ~~~~~~    ~~    ~~~~~  
#                 ~     ~  ~        ~  ~   ~    ~ 
#                 ~~~~~~~  ~~~~~   ~    ~  ~    ~ 
#                 ~     ~  ~       ~~~~~~  ~~~~~  
#                 ~     ~  ~       ~    ~  ~      
#                 ~     ~  ~~~~~~  ~    ~  ~      
#                                                 

def checkMinHeap(cfg, server, desiredSize = '128'):
	heap(cfg, server, 'check', desiredSize, 'initialHeapSize')


def checkMaxHeap(cfg, server, desiredSize = '512'):
	heap(cfg, server, 'check', desiredSize, 'maximumHeapSize')


def setMinHeap(cfg, server, desiredSize = '128'):
	heap(cfg, server, 'set', desiredSize, 'initialHeapSize')


def setMaxHeap(cfg, server, desiredSize = '512'):
	heap(cfg, server, 'set', desiredSize, 'maximumHeapSize')


def heap(cfg, server, request, desiredSize, param):
	# Help: Display syntax
	if desiredSize == 'help':
# 		print "Syntax: %s%sHeap(cfg, server, request = 'check', desiredSize = '128')" % (('check', 'set')[ request == 'set' ], ('Min', 'Max')[ param == 'maximumHeapSize' ])) 
		print ""
		print "   desiredSize      is in MegaBytes"
		print ""
		return True

	# Get params
	jvm = AdminConfig.list('JavaVirtualMachine', server[ 'ID' ])
	# provided arg 'param' is either 'initialHeapSize' or 'maximumHeapSize'
	minHeap = AdminConfig.showAttribute(jvm, param)

	# If heap = desired, skip all of this & will return true below

	if minHeap != desiredSize:
		# Return False if check
		if request == 'check':
			return False
		# Set it to desired
		elif request == 'set':
			try:
				AdminConfig.modify( jvm, [[ param, desiredSize ]] )
			except:
				return False
		# Unhandled bugger up
		else:
			print "Error, Somethings gone wrong"
			return False
	
	# Everything either returns False or comes here
	return True



def getServerInfo(cfg, server):

    try:
	AdminConfig  = cfg.AdminConfig
	AdminControl = cfg.AdminControl
    except: 
	print "Can Load the wsadmin Modules"

    minHeap = 0
    maxHeap = 0

    #print '>;GETHEAP ' + str(server)

    jvmlisttxt = AdminConfig.list('JavaVirtualMachine', server[ 'ID' ])

    jvmlist = jvmlisttxt.split(lineSeparator)

    if len(jvmlist) > 0:

      jvm = jvmlist[0]
      #print jvm

      minHeap = AdminConfig.showAttribute(jvm, 'initialHeapSize')
      maxHeap = AdminConfig.showAttribute(jvm, 'maximumHeapSize')

    info = {'minheap':minHeap, 'maxheap':maxHeap}
 
    #print '<;GETHEAP ' + str(server)

    return info



#=======================================================================
#                                          
#  Get Info from AppServer and write out Introscope STATS
#                    
#=======================================================================

def outputServerInfoToIntroscope(cfg, server, i): 

    info = getServerInfo(cfg, server) 

    if not server.has_key('serverMetricName'):
          server['serverMetricName'] = server[ 'name' ] + '_' + server[ 'nodeName' ]
    
    #print info

    for k in info.keys():
       #print "%s = %s" % (k,info[k])
       i.metric( "IntCounter", 
	          [ server[ 'cellName' ],
	            server[ 'clusterName' ],
	            server[ 'serverMetricName' ],
                    "stats",
	            k 
	          ],
	         info[k] 
	        ) 

#=======================================================================
#                 ~~~~~~~                         
#                    ~     ~~~~~~   ~~~~    ~~~~~ 
#                    ~     ~       ~          ~   
#                    ~     ~~~~~    ~~~~      ~   
#                    ~     ~            ~     ~   
#                    ~     ~       ~    ~     ~   
#                    ~     ~~~~~~   ~~~~      ~   
#                                                 
#=======================================================================

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Tests a single Application Server, outputType can be --
# 
# Tests (and response code)--
#  print AdminControl.getAttribute(AdminConfig.getObjectName('SysOrmASIP2M2(cells/SysOrmCell/nodes/uaswas11N3/servers/SysOrmASIP2M2|server.xml#Server_1270081863334)'), 'state' )
#   STARTED
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

def testServerUp(cfg, server): 
	try:
		AdminConfig  = cfg.AdminConfig
		AdminControl = cfg.AdminControl
	except: 
		print "Can Load the wsadmin Modules"


        #print "TEST SERVERUP" + str(server)

	# define the iterator and/or check if it is time to check yet
	if iterationTime( cfg, server, cfg.svrIterationTime ) == None:
		return None

	# Get the ObjectName of the server 
	#  (this does test whether the App Server is up, but its not "the test"

	if not server.has_key('objectNm'):
		server[ 'objectNm' ] = getObjectName( cfg, server[ 'ID' ] ) 

	if server.has_key('objectNm'):
		if server[ 'objectNm' ] == '':  
			server[ 'objectNm' ] = getObjectName( cfg, server[ 'ID' ] ) 


	# Do the Check
	try:
		result = AdminControl.getAttribute( server[ 'objectNm' ], 'state' )
		server[ 'lastStatus' ] = { 'bool': '1', 'msg': 'Started', 'time': time.time(), 'stime':strftime("%H:%M:%S", gmtime()) }
	except:
	        server[ 'objectNm' ] = ''
		server[ 'lastStatus' ] = { 'bool': '0', 'msg': 'Stopped', 'time': time.time(), 'stime':strftime("%H:%M:%S", gmtime()) }

	dateIteration( cfg, server )

        #print "TEST SERVERUP x" + str(server)

	return server[ 'lastStatus' ]


        
