#!/usr/bin/python
#
# vim:set syntax=python:
import sys
import re
import types
import time
# import IAG.log 
class config:


	def __init__(self):                                       # Instanciation method
		self.iterations = 0                                     # Number of times the prog have iterated through its main cycle
		self.startDate  = time.asctime( time.localtime(time.time()) ) # Start time of prog
		self.type       = "config"

	def setTask(self,request=[ ]):                            # Defines task -> Control property -> defines what people do
		self.task = request

	
	def loadCfg(self, file, cfgType = "conf", obj = 'default' ):

		# This function opens a file and starts processing it 
		# as config (name, value), applying it to 'obj'

		if type( obj ) is type(""):
			obj = self
		if not hasattr(obj, 'data'):
			obj.data = {}
		try:
			cfgFile = open( file, 'r' )
		except: 
			self.cfg.log.warn("Couldn't open config file '%s'. Load failed.")
			return
		self.tmpLineNo = 0
		while cfgFile:
			line = cfgFile.readline()
			if not line:
				break
			self.tmpLineNo = self.tmpLineNo + 1
			line = line.rstrip()
			self.addToCfg( str( line ), obj, cfgType )
		cfgFile.close()              
		
		
	def addToCfg (self, line, obj, cfgType = 'conf'):
	
		# This function takes a cfg instruction, in the format of 
		# (not including the hash pfx, which would cause it to be 
		# ignored):
		#     section.name.of.setting = value 
		# then it applies it to, obj as a complex dict struct
		# note 

		if re.match('^\s*#', line):
	# 		print 'Skipping comment: %s' % line  
			return
		if not re.match(r'^\s*\S+\s*=\s*.+\s*$', line):
	# 		print 'Skipping Dodgy line: %s' % line 
			return
		m = re.match(r'^\s*(\S+)\s*=\s*(.+)\s*$', line)
		names = m.group(1).split('.')
		value = m.group(2)
		count = 0
		curObj = obj.data 
		strLen = 0
	
		while count < len(names):
			if count == 0:
				pass
# 				self.mComp: 
			else:
				strLen = strLen + len( names[ count - 1 ] )           # This bit helps position the ^'s when showing err msgs
			

# 			if count < len(names) - 2:                              # If not the second last name element, create dict, else assign value to str 
# 				if not hasattr(obj, 'data')    

			if count < len(names) - 1:                              # If not the last name element, create dict, else assign value to str
				if not curObj.has_key( names[ count ] ):              # Does this already exist, if wrong type (list,str) then have a spazzy
					curObj[ names[ count] ] = {}
					curObj2 = curObj[ names[ count ] ]
					curObj = curObj2
					count =	count + 1
					continue
				else:                                                 # the element already exists, check they agree and move on
					if type(curObj[ names[count] ]) is type({}):
						curObj = curObj[ names[count] ]
						count =	count + 1
						continue                                          # It exists, already assigned, not last one. Next!
					else:
						self.cfg.log.warn( "\n     --- THIS LINE IS DUMB, A VALUE HAS BEEN ASSIGNED TO COMPONENT %s, '%s'" %  ( (count + 1) , names[ count ]))
						self.cfg.log.warn( " (%3s): %s" % (self.tmpLineNo, line))
						self.cfg.log.warn( "        %s%s" % (" " * (strLen + count), "^" * len( names[ count ] ), ))
						self.cfg.log.warn( "     --- Your config is most likely stuffed and needs some TLC. This is not a good thing to happen")
						self.cfg.log.warn( "     --- Replacing value: %s, with some kinda other . . . thing: %s" % (curObj[ names[ count ] ], line))
						curObj[ names[ count ] ] = {}
						curObj = curObj[ names[ count ] ]
						count =	count + 1
						continue                                          # It exists, already assigned, not last one. Next!
			else:                                                   # This is the last element of the name
				if not curObj.has_key(names[count]):                  # Does this already exist, if wrong type (list,str) then have a spazzy
					curObj[ names[ count ] ] = {}
					curObj[ names[ count ] ][ cfgType ] = value
					count =	count + 1
					continue                                          
				else:	
					self.cfg.log.warn( "     --- DUPLICATE ENTRY, OVERRIDING VALUE: %s, WITH VALUE FROM LINE %s: %s" % (curObj[ names[ count ] ], self.tmpLineNo, value ) )
					self.cfg.log.warn( " (%3s): %s" % (self.tmpLineNo, line) )
					curObj[ names[ count ] ][ cfgType ] = value
					count =	count + 1
					continue
	
			count =	count + 1
			
	def listSettings( self, cfgType = 'all' ):
		print "\nDumping Config"
		print "=============="
		if type( self.data ) is type({}):
			self.listDictCfg( self.data, "" )
		if type( self.data ) is type([]):
			self.listDictCfg( self.data, "" )
		if type( self.data ) is type(""):
			print "listSettings-- Actually this is but a single value: %s" % self.data
	
	def listDictCfg( self, obj, nameSoFar ):
		spacer = ''
		for thisLevel in obj.keys():
	
			if type( obj[ thisLevel ] ) is type({}):
	# 			print "%s." % thisLevel,
				if nameSoFar <> '': spacer = '.'
				self.listDictCfg( obj[ thisLevel ], str( nameSoFar + spacer + thisLevel ) )
			if type( obj[ thisLevel ] ) is type([]):
	# 			print "%s." % thisLevel,
				self.listDictCfg( obj[ thisLevel ] )
			if type( obj[ thisLevel ] ) is type(""):
				print "%s = %s" % ( nameSoFar,  obj[ thisLevel ])
	
		
	# class config: 
	# 	def __init__: 
	# 		load=0 
	# 		save=0 
	# 		cfg = {} 
	# 		for arg in args: 
	# 			if arg == 'load': 
	# 				load=1 
	# 			if arg == 'save': 
	# 				save=1 
	# 		if load == 1: 
	#  
	# # 		print "Loading System Configuration" 
	# # 		loadCfg( cfg, 'settings.cfg', 'defCell' ) 
	# # 		print "Config File: %s loaded" % "settings.cfg"  
	#  
	# # 		print "Loading Default Configuration" 
	# # 		loadCfg( cfg, 'settings.cfg', 'defCell' ) 
	# # 		print "Config File: %s loaded" % "settings.cfg"  
	#  
	# 		print "Loading Cell Configuration" 
	# 		loadCfg( cfg, 'settings.cfg', 'defCell', cfg, 'conf') 
	# 		print "Config File: %s loaded" % "settings.cfg"  
	#  
	# # 		print "Loading Server Configuration" 
	# # 		loadCfg( cfg, 'settings.cfg', 'defCell' ) 
	#  
	# 		listSettings( cfg[ 'cell' ], 'cfg' ) 
	# # 		listSettings( cfg[ 'cell' ], ') 
	# # 		listSettings( cfg[ 'cell' ], ') 
	# # 		listSettings( cfg[ 'cell' ], 'def' ) 




# 		if self.type in [ 'system' ]: 
# 			pass 
# 		if self.type in [ 'defCell', 'cell' ]: 
# 			if not obj.data.has_key('cell'): 
# 				obj.data[ 'cell' ] = { 'server':{} } 
# 			obj = obj[ 'cell' ] 
# 		if self.type in [ 'server' ]: 
# 			if not obj.has_key('server'): 
# 				print "ERROR: There is not pre-declared server dictionary in provided object. Therefore this cfg request is stuffed and isn't going to be processed" 
# 				return 
# 			obj = obj[ 'server' ] 
